#import <Cocoa/Cocoa.h>
#include <objc/runtime.h>

@interface NSObject (Annotated)
- (NSString*)annotation;
- (void)setAnnotation: (NSString*)aString;
@end
static char key;
@implementation NSObject (Annotated)
- (NSString*)annotation
{
	return objc_getAssociatedObject(self, &key);
}
- (void)setAnnotation: (NSString*)aString
{
	objc_setAssociatedObject(self, &key, aString, OBJC_ASSOCIATION_RETAIN);
}
@end

int main(void)
{
	[NSAutoreleasePool new];
	id obj = [NSDictionary new];
	[obj setAnnotation: @"A note"];
	NSLog(@"Annotation: %@", [obj annotation]);
	return 0;
}
