#import <Foundation/Foundation.h>
#include <objc/runtime.h>

id fakeDealloc(id self, SEL _cmd, ...)
{
	NSLog(@"%@ sent a -dealloc message", self);
}

void makeIndestructible(id obj)
{
	Class new = 
		objc_allocateClassPair(obj->isa, "Fake", 0);
	class_addMethod(new, @selector(dealloc), 
			fakeDealloc, "v@:");
	objc_registerClassPair(new);
	obj->isa = new;
}

int main(void)
{
	[NSAutoreleasePool new];
	id obj = [NSObject new];
	// Note: A second call to this will fail because the Fake class already
	// exists.
	makeIndestructible(obj);
	[obj release];
	return 0;
}
