#import <Foundation/Foundation.h>

@interface DownloadDelegate : NSObject
{
	int progress;
	long long fetched;
	long long size;
}
@end
@implementation DownloadDelegate
- (void)downloadDidBegin: (NSURLDownload*)download
{
	NSLog(@"Started downloading");
}
-   (void)download: (NSURLDownload*)download
didReceiveResponse: (NSURLResponse*)response
{
	size = [response expectedContentLength];
}
-       (void)download: (NSURLDownload*)download
didReceiveDataOfLength:(NSUInteger)length
{
	fetched += length;
	for (int newProgress = (fetched * 100) / size ; newProgress > progress ; progress++)
	{
		putc('.', stderr);
	}
}
- (void)download: (NSURLDownload*)download
didFailWithError: (NSError*)error
{
	NSLog(@"Error: %@", [error localizedDescription]);
	exit(1);
}
- (void)downloadDidFinish: (NSURLDownload*)download
{
	NSLog(@"Finished downloading");
	exit(0);
}
@end

int main(void)
{
	[NSAutoreleasePool new];
	NSArray *args = [[NSProcessInfo processInfo] arguments];
	NSString *target = [args objectAtIndex: 1];
	NSURL *targetURL = [NSURL URLWithString: target];
	if (nil == targetURL) { return 1; }
	NSURLRequest *req = [NSURLRequest requestWithURL: targetURL];
	id delegate = [DownloadDelegate new];
	NSURLDownload *dl =
		[[NSURLDownload alloc] initWithRequest: req
		                              delegate: delegate];
	[dl setDestination: [targetURL lastPathComponent]
	    allowOverwrite: YES];
	[[NSRunLoop currentRunLoop] run];
}
